/* 
 * S-Market: "    " 
 *    "-", 2013  
 */ 

SET TERM ^ ;

create or alter procedure RPT_ALKODECLOBOROT_OBOSOB (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    GROUP_BY_SUPERPLACE integer)
returns (
    CL_ID integer,
    CL_NAME varchar(255),
    CL_INN varchar(20),
    CL_KPP varchar(20),
    CL_ADDRESS varchar(255),
    CL_COUNTRY_KOD varchar(3),
    CL_POST_INDEX varchar(6),
    CL_REGION varchar(2),
    CL_DISTRICT varchar(40),
    CL_CITY varchar(100),
    CL_CITY_CLEAR varchar(40),
    CL_NAS_PUNKT varchar(40),
    CL_STREET varchar(40),
    CL_HOUSE varchar(20),
    CL_HOUSE_CLEAR varchar(7),
    CL_BUILDING varchar(7),
    CL_APPARTMENT varchar(7))
AS
declare variable li_place integer;
begin

  cl_id = -1; cl_name = '-'; cl_inn = '-'; cl_kpp = '-';
  cl_address = ''; cl_post_index = ''; cl_region = ''; cl_district = '';
  cl_city = ''; cl_street = ''; cl_house = '';

  if (group_by_superplace = 1) then begin
    select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
    for select distinct cl.id_clients, iif(cl.legal_name <> '', cl.legal_name, cl.name_clients),  iif(cl.inn_clients <> '', cl.inn_clients, '-'), iif(cl.kpp <> '', cl.kpp, '-'),
               ad.address, ad.country_kod, ad.post_index, ad.region_kod, ad.district_name,
               iif(ad.nas_punkt = '', ad.city_name, ad.city_name ||' \ ')||ad.nas_punkt,
               ad.city_name, ad.nas_punkt,
               ad.street_name, ad.house || iif (ad.building <> '', ' \ ' || ad.building, ''),
               ad.house, ad.building, ad.appartment
      from SUPERPLACE sp
      left join SUPERPLACE_HEAD sph on sph.id = sp.id
      inner join CLIENTS cl on cl.id_clients = sph.client_index
      left join GET_ADDRESS_KLADR(0, cl.id_clients) ad on 1=1
      where sp.spkind = 12 and listint_exists(:li_place, sp.placeindex) = 1
      into :cl_id, :cl_name, :cl_inn, :cl_kpp,
           :cl_address, :cl_country_kod, :cl_post_index, :cl_region, :cl_district,
           :cl_city,
           :cl_city_clear, :cl_nas_punkt,
           :cl_street, :cl_house,
           :cl_house_clear, :cl_building, :cl_appartment
    do suspend;
    execute procedure RPT_LISTS_FREE;
  end else begin
    select cl.id_clients, iif(cl.legal_name <> '', cl.legal_name, cl.name_clients),  iif(cl.inn_clients <> '', cl.inn_clients, '-'), iif(cl.kpp <> '', cl.kpp, '-'),
           ad.address, ad.country_kod, ad.post_index, ad.region_kod, ad.district_name,
           iif(ad.nas_punkt = '', ad.city_name, ad.city_name ||' \ ')||ad.nas_punkt,
           ad.city_name, ad.nas_punkt,
           ad.street_name, ad.house || iif (ad.building <> '', ' \ ' || ad.building, ''),
           ad.house, ad.building, ad.appartment
      from CLIENTS cl
      left join GET_ADDRESS_KLADR(0, :from_name_id) ad on 1=1
      where cl.id_clients = :from_name_id
    into :cl_id, :cl_name, :cl_inn, :cl_kpp,
         :cl_address, :cl_country_kod, :cl_post_index, :cl_region, :cl_district,
         :cl_city,
         :cl_city_clear, :cl_nas_punkt,
         :cl_street, :cl_house,
         :cl_house_clear, :cl_building, :cl_appartment;
    suspend;
  end
end^

create or alter procedure RPT_ALKODECLOBOROT_SPEC (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    GROUP_BY_SUPERPLACE integer,
    MANUF_KIND integer,
    VIDPROD_KIND integer)
returns (
    DOCHEAD_ID integer,
    VIDPROD_ID integer,
    SUPERPLACE_CL_ID integer,
    MANUF_ID integer,
    OST_BEGIN double precision,
    PRIX_PROIZ double precision,
    PRIX_OPT double precision,
    PRIX_IMPORT double precision,
    PRIX_RET double precision,
    PRIX_MOVE double precision,
    PRIX_OTHER double precision,
    RASX_OPT double precision,
    RASX_ROZN double precision,
    RASX_EXPORT double precision,
    RASX_RET double precision,
    RASX_MOVE double precision,
    RASX_OTHER double precision)
AS
declare variable v_docdate date;
declare variable v_quantity double precision;
declare variable v_client_index integer;
declare variable v_client2_index integer;
declare variable v_dockind integer;
declare variable v_real_dockind integer;
declare variable v_opertype integer;
declare variable v_suptype integer;
declare variable v_buytype integer;
declare variable v_netto double precision;
declare variable v_articul varchar(30);
declare variable ls_articul integer;
declare variable li_place integer;
declare variable v_superplace_cl_id integer;
declare variable v_out_superplace_cl_id integer;
begin
  select handle from RPT_LIST_ARTICUL_CREATE(:report_id, :owner_id, '0;2') into :ls_articul;
  select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;

  v_superplace_cl_id = from_name_id;

  for select dh.id_dochead, dh.doc_date, dh.client_index, dh.client2_index, op.opertype, dh.dockind
    from DOCHEAD dh
    left join OPERATIONS op on dh.operation = op.id_operation
    where dh.accept = 'T' and dh.doc_date <= :date_last and
          (dh.dockind in (0,1,2) and listint_exists(:li_place, dh.client2_index) = 1 or
           dh.dockind = 2 and listint_exists(:li_place, dh.client_index) = 1)
    into :dochead_id, :v_docdate, :v_client_index, :v_client2_index, :v_opertype, :v_dockind
  do begin
    v_real_dockind = v_dockind;
    --        
    select coalesce(alko_sup_type, 0), coalesce(alko_buy_type,1) from CLIENTS
      where id_clients = :v_client_index
    into v_suptype, v_buytype;
    --  
    if (group_by_superplace = 1) then begin
      v_superplace_cl_id = null;
      select sph.client_index
        from SUPERPLACE sp
        left join SUPERPLACE_HEAD sph on sph.id = sp.id
        where sp.spkind = 12 and sp.placeindex = :v_client2_index
      into v_superplace_cl_id;
      if (v_dockind = 2) then begin
        if (listint_exists(:li_place, v_client2_index) <> 1)
          then v_superplace_cl_id = null;
        v_out_superplace_cl_id = null;
        if (listint_exists(:li_place, v_client_index) = 1)
          then select sph.client_index
                 from SUPERPLACE sp
                 left join SUPERPLACE_HEAD sph on sph.id = sp.id
                 where sp.spkind = 12 and sp.placeindex = :v_client_index
               into v_out_superplace_cl_id;
        if (v_superplace_cl_id is null) then begin
          --  "" -   
          v_opertype = 2; -- ""
          v_dockind = 1;
          v_superplace_cl_id = v_out_superplace_cl_id; --   ,   = client_index
        end else
        if (v_out_superplace_cl_id is null) then begin
          --  "" -   
          v_opertype = 2; -- ""
          v_dockind = 0;
        end else
        if (v_out_superplace_cl_id = v_superplace_cl_id) then begin
          --    -   
          v_dockind = -1;
        end
        --        (-)
        --       -     
      end
    end else begin
      if (v_dockind = 2) then begin
        v_opertype = 2; -- ""
        if (listint_exists(:li_place, v_client_index)=1 and
            listint_exists(:li_place, v_client2_index)<>1)
          then v_dockind = 1; --   
          else if (listint_exists(:li_place, v_client_index)<>1 and
                   listint_exists(:li_place, v_client2_index)=1)
                 then v_dockind = 0; --   
                 else v_dockind = -1; --  
      end
    end

    if (v_superplace_cl_id is not null and v_dockind <> -1) then begin

      for select iif(:vidprod_kind = 0, cp.paramvalue, dsp.vidprod),
                 coalesce(iif(:manuf_kind = 0, cs.manufacturer, ds.manufacturer),-1),
                 ds.quantity * cs.netto, cs.netto, ds.articul
        from DOCSPEC ds
        left join CARDPARAMS cp on :vidprod_kind = 0 and ds.articul = cp.articul and cp.paramtype = 7
        left join DOCSPEC_PARAMS dsp on (:vidprod_kind = 1 or :vidprod_kind = 2 and :v_real_dockind = 0 and :v_opertype <> 1) and
                                        dsp.dochead = :dochead_id and dsp.articul = ds.articul
        left join CARDSCLA cs on ds.articul = cs.articul
        where ds.id_dochead = :dochead_id and liststr_exists(:ls_articul, ds.articul) = 1
        into :vidprod_id, :manuf_id, :v_quantity, :v_netto, :v_articul
      do begin

        for select iif(:vidprod_kind = 2, dsp.vidprod, :vidprod_id),
                   coalesce(iif(:manuf_kind = 2, ds.manufacturer, :manuf_id),-1),
                   rs.quantity * :v_netto
              from RDB$DATABASE
              left join RETSPEC rs on rs.dochead = :dochead_id and rs.articul = :v_articul
              left join DOCSPEC ds on :manuf_kind = 2 and ds.id_dochead = rs.indochead and ds.articul = :v_articul
              left join DOCSPEC_PARAMS dsp on :vidprod_kind = 2 and dsp.dochead = rs.indochead and dsp.articul = :v_articul
              where :v_real_dockind = 0 and :v_opertype = 1 and (:vidprod_kind = 2 or :manuf_kind = 2)
            union all
            select iif(:vidprod_kind = 2, dsp.vidprod, :vidprod_id),
                   coalesce(iif(:manuf_kind = 2, ds.manufacturer, :manuf_id),-1),
                   ps.quantity * :v_netto
              from RDB$DATABASE
              left join PARTSPEC ps on ps.dochead = :dochead_id and ps.articul = :v_articul
              left join DOCSPEC ds on :manuf_kind = 2 and ds.id_dochead = ps.indochead and ds.articul = :v_articul
              left join DOCSPEC_PARAMS dsp on :vidprod_kind = 2 and dsp.dochead = ps.indochead and dsp.articul = :v_articul
              where :v_real_dockind in (1,2) and (:vidprod_kind = 2 or :manuf_kind = 2)
            union all
            select :vidprod_id, :manuf_id, :v_quantity
              from RDB$DATABASE
              where :v_real_dockind = 0 and :v_opertype <> 1 or
                    :vidprod_kind <> 2 and :manuf_kind <> 2
          into :vidprod_id, :manuf_id, :v_quantity
        do begin
          if (vidprod_id is not null) then begin
            superplace_cl_id = v_superplace_cl_id;
            ost_begin = 0;
            prix_proiz = 0; prix_opt = 0; prix_import = 0; prix_ret = 0; prix_move = 0; prix_other = 0;
            rasx_opt = 0; rasx_rozn = 0; rasx_export = 0; rasx_ret = 0; rasx_move = 0; rasx_other = 0;

            --   
            if (v_docdate < date_first) then begin
              if (v_dockind = 0)
                then ost_begin = v_quantity;
                else if (v_dockind = 1)
                       then ost_begin = -v_quantity;
                       else if (v_dockind = 2) then begin
                              ost_begin = v_quantity;
                              suspend;
                              ost_begin = 0;
                              superplace_cl_id = v_out_superplace_cl_id;
                              ost_begin = -v_quantity;
                            end
            end
            --    
            else begin
              -- 
              if (v_dockind = 0) then begin
                if (v_opertype = 1)
                  then prix_ret = v_quantity;
                  else if (v_opertype = 2 or v_opertype = 3)
                         then prix_other = v_quantity;
                         else if (v_suptype = 0)
                                then prix_proiz = v_quantity;
                                else if (v_suptype = 1)
                                       then prix_opt = v_quantity;
                                       else if (v_suptype = 2)
                                              then prix_import = v_quantity;
              end
              -- 
              if (v_dockind = 1) then begin
                if (v_opertype = 1)
                  then rasx_ret = v_quantity;
                  else if (v_opertype = 2 or v_opertype = 3)
                         then rasx_other = v_quantity;
                         else if (v_buytype = 0)
                                then rasx_opt = v_quantity;
                                else if (v_buytype = 1)
                                       then rasx_rozn = v_quantity;
                                       else if (v_buytype = 2)
                                              then rasx_export = v_quantity;

              end
              -- 
              if (v_dockind = 2) then begin
                prix_move = v_quantity;
                suspend;
                prix_move = 0;
                superplace_cl_id = v_out_superplace_cl_id;
                rasx_move = v_quantity;
              end
            end
            suspend;
          end
        end
      end
    end
  end
  execute procedure RPT_LISTS_FREE;
end^

create or alter procedure RPT_ALKODECLOBOROT (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    CALC_PRECISION integer,
    GROUP_BY_SUPERPLACE integer,
    MANUF_KIND integer,
    VIDPROD_KIND integer)
returns (
    SUPERPLACE_CL_ID integer,
    VIDPROD_NAME varchar(80),
    VIDPROD_KOD varchar(40),
    MANUF_ID integer,
    MANUF_NAME varchar(255),
    MANUF_INN varchar(20),
    MANUF_KPP varchar(20),
    OST_BEGIN double precision,
    PRIX_PROIZ double precision,
    PRIX_OPT double precision,
    PRIX_IMPORT double precision,
    PRIX_RET double precision,
    PRIX_MOVE double precision,
    PRIX_OTHER double precision,
    RASX_OPT double precision,
    RASX_ROZN double precision,
    RASX_EXPORT double precision,
    RASX_RET double precision,
    RASX_MOVE double precision,
    RASX_OTHER double precision)
AS
declare variable v_vidprod_id integer;
begin
  setpriority(-15);

  for select superplace_cl_id, vidprod_id, manuf_id, sum(ost_begin),
             sum(prix_proiz), sum(prix_opt),
             sum(prix_import), sum(prix_ret),
             sum(prix_move), sum(prix_other),
             sum(rasx_opt), sum(rasx_rozn),
             sum(rasx_export), sum(rasx_ret),
             sum(rasx_move), sum(rasx_other)
    from (select superplace_cl_id, vidprod_id, manuf_id, round(sum(ost_begin)/10, :calc_precision) ost_begin,
                 round(sum(prix_proiz)/10, :calc_precision) prix_proiz, round(sum(prix_opt)/10, :calc_precision) prix_opt,
                 round(sum(prix_import)/10, :calc_precision) prix_import, round(sum(prix_ret)/10, :calc_precision) prix_ret,
                 round(sum(prix_move)/10, :calc_precision) prix_move, round(sum(prix_other)/10, :calc_precision) prix_other,
                 round(sum(rasx_opt)/10, :calc_precision) rasx_opt, round(sum(rasx_rozn)/10, :calc_precision) rasx_rozn,
                 round(sum(rasx_export)/10, :calc_precision) rasx_export, round(sum(rasx_ret)/10, :calc_precision) rasx_ret,
                 round(sum(rasx_move)/10, :calc_precision) rasx_move, round(sum(rasx_other)/10, :calc_precision) rasx_other
            from RPT_ALKODECLOBOROT_SPEC (:report_id, :owner_id, :from_name_id, :date_first, :date_last, :group_by_superplace, :manuf_kind, :vidprod_kind)
            where vidprod_id is not null
            group by superplace_cl_id, vidprod_id, manuf_id, dochead_id)
    group by superplace_cl_id, vidprod_id, manuf_id
    into superplace_cl_id, :v_vidprod_id, :manuf_id, :ost_begin,
         :prix_proiz, :prix_opt,
         :prix_import, :prix_ret,
         :prix_move, :prix_other,
         :rasx_opt, :rasx_rozn,
         :rasx_export, :rasx_ret,
         :rasx_move, :rasx_other
  do begin
    if (cmp_dbl_e(ost_begin, 0) <> 0 or
        cmp_dbl_e(prix_proiz, 0) <> 0 or cmp_dbl_e(prix_opt, 0) <> 0 or
        cmp_dbl_e(prix_import, 0) <> 0 or cmp_dbl_e(prix_ret, 0) <> 0 or
        cmp_dbl_e(prix_move, 0) <> 0 or cmp_dbl_e(prix_other, 0) <> 0 or
        cmp_dbl_e(rasx_opt, 0) <> 0 or cmp_dbl_e(rasx_rozn, 0) <> 0 or
        cmp_dbl_e(rasx_export, 0) <> 0 or cmp_dbl_e(rasx_ret, 0) <> 0 or
        cmp_dbl_e(rasx_move, 0) <> 0 or cmp_dbl_e(rasx_other, 0) <> 0) then begin

      select name, kod
        from VID_PROD
        where id = :v_vidprod_id
      into vidprod_name,  vidprod_kod;

      if (manuf_id is null or manuf_id = -1) then begin
        manuf_id = -1;
        manuf_name = '< >'; manuf_inn = ''; manuf_kpp = '';
      end else begin
        select iif(m.legal_name <> '', m.legal_name, m.name_manufacturer), m.inn, m.kpp
          from MANUFACTURER m
          where m.id_manufacturer = :manuf_id
        into manuf_name, manuf_inn, manuf_kpp;
      end
      suspend;
    end
  end
end^

GRANT EXECUTE ON PROCEDURE RPT_ALKODECLOBOROT_OBOSOB TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLOBOROT_SPEC TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLOBOROT TO PUBLIC^

SET TERM ; ^

COMMIT;
