/* 
 * S-Market: "     " 
 *    "-", 2013  
 */ 

SET TERM ^ ;

create or alter procedure RPT_ALKODECLROZN_OBOSOB (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    GROUP_BY_SUPERPLACE integer)
returns (
    CL_ID integer,
    CL_NAME varchar(255),
    CL_INN varchar(20),
    CL_KPP varchar(20),
    CL_ADDRESS varchar(255),
    CL_COUNTRY_KOD varchar(3),
    CL_POST_INDEX varchar(6),
    CL_REGION varchar(2),
    CL_DISTRICT varchar(40),
    CL_CITY varchar(100),
    CL_CITY_CLEAR varchar(40),
    CL_NAS_PUNKT varchar(40),
    CL_STREET varchar(40),
    CL_HOUSE varchar(20),
    CL_HOUSE_CLEAR varchar(7),
    CL_BUILDING varchar(7),
    CL_APPARTMENT varchar(7))
AS
declare variable li_place integer;
begin

  cl_id = -1; cl_name = '-'; cl_inn = '-'; cl_kpp = '-';
  cl_address = ''; cl_post_index = ''; cl_region = ''; cl_district = '';
  cl_city = ''; cl_street = ''; cl_house = '';

  if (group_by_superplace = 1) then begin
    select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
    for select distinct cl.id_clients, iif(cl.legal_name <> '', cl.legal_name, cl.name_clients),  iif(cl.inn_clients <> '', cl.inn_clients, '-'), iif(cl.kpp <> '', cl.kpp, '-'),
               ad.address, ad.country_kod, ad.post_index, ad.region_kod, ad.district_name,
               iif(ad.nas_punkt = '', ad.city_name, ad.city_name ||' \ ')||ad.nas_punkt,
               ad.city_name, ad.nas_punkt,
               ad.street_name, ad.house || iif (ad.building <> '', ' \ ' || ad.building, ''),
               ad.house, ad.building, ad.appartment
      from SUPERPLACE sp
      left join SUPERPLACE_HEAD sph on sph.id = sp.id
      inner join CLIENTS cl on cl.id_clients = sph.client_index
      left join GET_ADDRESS_KLADR(0, cl.id_clients) ad on 1=1
      where sp.spkind = 12 and listint_exists(:li_place, sp.placeindex) = 1
      into :cl_id, :cl_name, :cl_inn, :cl_kpp,
           :cl_address, :cl_country_kod, :cl_post_index, :cl_region, :cl_district,
           :cl_city,
           :cl_city_clear, :cl_nas_punkt,
           :cl_street, :cl_house,
           :cl_house_clear, :cl_building, :cl_appartment
    do suspend;
    execute procedure RPT_LISTS_FREE;
  end else begin
    select cl.id_clients, iif(cl.legal_name <> '', cl.legal_name, cl.name_clients),  iif(cl.inn_clients <> '', cl.inn_clients, '-'), iif(cl.kpp <> '', cl.kpp, '-'),
           ad.address, ad.country_kod, ad.post_index, ad.region_kod, ad.district_name,
           iif(ad.nas_punkt = '', ad.city_name, ad.city_name ||' \ ')||ad.nas_punkt,
           ad.city_name, ad.nas_punkt,
           ad.street_name, ad.house || iif (ad.building <> '', ' \ ' || ad.building, ''),
           ad.house, ad.building, ad.appartment
      from CLIENTS cl
      left join GET_ADDRESS_KLADR(0, :from_name_id) ad on 1=1
      where cl.id_clients = :from_name_id
    into :cl_id, :cl_name, :cl_inn, :cl_kpp,
         :cl_address, :cl_country_kod, :cl_post_index, :cl_region, :cl_district,
         :cl_city,
         :cl_city_clear, :cl_nas_punkt,
         :cl_street, :cl_house,
         :cl_house_clear, :cl_building, :cl_appartment;
    suspend;
  end
end^

create or alter procedure RPT_ALKODECLROZN_BUY_SPEC (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    GROUP_BY_SUPERPLACE integer,
    MANUF_KIND integer,
    VIDPROD_KIND integer,
    USE_SEL_CLIENTS integer,
    SHOW_NULL_NETTO integer)
returns (
    SUPERPLACE_CL_ID integer,
    VIDPROD_ID integer,
    CLIENT_ID integer,
    MANUF_ID integer,
    EXT_DOC_DATE date,
    EXT_DOCINDEX T_EXT_DOC_INDEX,
    ARTICUL varchar(30),
    NETTO double precision,
    QUANTITY double precision,
    ISRET integer)
AS
declare variable v_dochead integer;
declare variable v_place integer;
declare variable ls_articul integer;
declare variable li_place integer;
declare variable li_client integer;
begin
  select handle from RPT_LIST_ARTICUL_CREATE(:report_id, :owner_id, '0;2') into :ls_articul;
  select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
  if (use_sel_clients = 1)
    then select handle from RPT_LIST_CLIENT2_CREATE(:report_id, :owner_id) into :li_client;

  superplace_cl_id = from_name_id;

  for select dh.id_dochead, dh.client_index, dh.client2_index,
             dh.ext_doc_date, dh.ext_docindex, op.opertype
    from DOCHEAD dh
    left join OPERATIONS op on dh.operation = op.id_operation
    where dh.accept = 'T' and
          dh.doc_date between :date_first and :date_last and
          dh.dockind = 0 and op.opertype = 0 and dh.doctype <> 1000 and
          listint_exists(:li_place, dh.client2_index) = 1 and
          (:use_sel_clients = 0 or listint_exists(:li_client, dh.client_index) = 1)
    into :v_dochead, :client_id, :v_place, :ext_doc_date, :ext_docindex, :isret
  do begin
    if (group_by_superplace = 1) then begin
      superplace_cl_id = null;
      select sph.client_index
        from SUPERPLACE sp
        left join SUPERPLACE_HEAD sph on sph.id = sp.id
        where sp.spkind = 12 and sp.placeindex = :v_place
      into superplace_cl_id;
    end
    if (superplace_cl_id is not null) then begin

      for select iif(:vidprod_kind = 0, cp.paramvalue, dsp.vidprod),
                 coalesce(iif(:manuf_kind = 0, cs.manufacturer, ds.manufacturer),-1),
                 ds.quantity, cs.netto, ds.articul
        from DOCSPEC ds
        left join CARDPARAMS cp on :vidprod_kind = 0 and ds.articul = cp.articul and cp.paramtype = 7
        left join DOCSPEC_PARAMS dsp on :vidprod_kind > 0 and dsp.dochead = :v_dochead and dsp.articul = ds.articul
        left join CARDSCLA cs on ds.articul = cs.articul
        where ds.id_dochead = :v_dochead and liststr_exists(:ls_articul, ds.articul) = 1
        into :vidprod_id, :manuf_id, :quantity, :netto, :articul
      do begin
        if (isret = 1 and (vidprod_kind = 2 or manuf_kind = 2)) then begin
          --    ,      ,     ...
          for select iif(:vidprod_kind = 2, dsp.vidprod, :vidprod_id),
                     coalesce(iif(:manuf_kind = 2, ds.manufacturer, :manuf_id),-1),
                     rs.quantity
            from RETSPEC rs
            left join DOCSPEC ds on :manuf_kind = 2 and ds.id_dochead = rs.indochead and ds.articul = :articul
            left join DOCSPEC_PARAMS dsp on :vidprod_kind = 2 and dsp.dochead = rs.indochead and dsp.articul = :articul
            where rs.dochead = :v_dochead and rs.articul = :articul
            into :vidprod_id, :manuf_id, :quantity
          do begin
            if (not show_null_netto = 1 or netto > 0) then quantity = quantity * netto;
            if (quantity > 0 and vidprod_id is not null) then suspend;
          end
        end else begin
          if (not show_null_netto = 1 or netto > 0) then quantity = quantity * netto;
          if (quantity > 0 and vidprod_id is not null) then suspend;
        end
      end

    end
  end
  execute procedure RPT_LISTS_FREE;
end^

create or alter procedure RPT_ALKODECLROZN_BUY (
    REPORT_ID integer,
    OWNER_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    CALC_PRECISION integer,
    GROUP_BY_SUPERPLACE integer,
    FROM_NAME_ID integer,
    MANUF_KIND integer,
    VIDPROD_KIND integer,
    USE_SEL_CLIENTS integer,
    GROUP_BY_ARTICUL integer,
    SHOW_NULL_NETTO integer)
returns (
    VIDPROD_NAME varchar(80),
    VIDPROD_KOD varchar(40),
    SUPERPLACE_CL_ID integer,
    CL_ID integer,
    CL_IS_IP integer,
    CL_NAME varchar(255),
    CL_INN varchar(20),
    CL_KPP varchar(20),
    CL_ADDRES varchar(255),
    CL_COUNTRY_KOD varchar(3),
    CL_POST_INDEX varchar(6),
    CL_REGION varchar(2),
    CL_DISTRICT_NAME varchar(40),
    CL_CITY_NAME varchar(40),
    CL_NAS_PUNKT varchar(40),
    CL_STREET_NAME varchar(40),
    CL_HOUSE varchar(7),
    CL_BUILDING varchar(7),
    CL_APPARTMENT varchar(7),
    CL_LIC_SERIES varchar(20),
    CL_LIC_NUMBER varchar(20),
    CL_LIC_DATE date,
    CL_LIC_GOOD_DATE date,
    CL_LIC_ORGAN varchar(255),
    CL_LIC_REG_NUMBER varchar(255),
    MANUF_ID integer,
    MANUF_NAME varchar(255),
    MANUF_INN varchar(20),
    MANUF_KPP varchar(20),
    EXT_DOC_DATE date,
    EXT_DOCINDEX T_EXT_DOC_INDEX,
    ARTICUL varchar(30),
    GOODNAME varchar(80),
    NETTO double precision,
    QUANTITY double precision,
    ISRET integer)
as
declare variable V_VIDPROD_ID integer;
begin
  setpriority(-15);

  for select vidprod_id, client_id, manuf_id, superplace_cl_id, ext_doc_date, ext_docindex,
             iif(:group_by_articul = 1, articul, null), iif(:group_by_articul = 1, netto, null),
             round(sum(quantity) / 10, :calc_precision), isret
    from RPT_ALKODECLROZN_BUY_SPEC (:report_id, :owner_id, :from_name_id, :date_first, :date_last,
                                    :group_by_superplace, :manuf_kind, :vidprod_kind, :use_sel_clients, :show_null_netto)
    group by isret, vidprod_id, client_id, manuf_id, superplace_cl_id, ext_doc_date, ext_docindex,
             iif(:group_by_articul = 1, articul, null), iif(:group_by_articul = 1, netto, null)
    into :v_vidprod_id, :cl_id, :manuf_id, :superplace_cl_id, :ext_doc_date, :ext_docindex,
         :articul, :netto, 
         :quantity, :isret
  do begin
    if (cmp_dbl_e(quantity, 0) <> 0) then begin
      select name, kod from VID_PROD where id = :v_vidprod_id
        into vidprod_name, vidprod_kod;
      if (vidprod_kod not in ('500','510','520')) then begin
        select iif(cl.legal_name <> '', cl.legal_name, cl.name_clients), cl.inn_clients, cl.kpp, ad.address, ad.region_kod,
               clic.lic_series, clic.lic_number, clic.lic_date, clic.lic_gooddate, clic.lic_organ, clic.lic_reg_number,
               ad.country_kod, ad.post_index, ad.district_name, ad.city_name, ad.nas_punkt,
               ad.street_name, ad.house, ad.building, ad.appartment, coalesce(ok.is_ip, 0)
          from CLIENTS cl
          left join OWNKIND ok on ok.id = cl.ownkind
          left join CLIENT_LIC_VIEW(cl.id_clients, :ext_doc_date) clic on 1=1
          left join GET_ADDRESS_KLADR(0, :cl_id) ad on 1=1
          where cl.id_clients = :cl_id
        into :cl_name, :cl_inn, :cl_kpp, :cl_addres, cl_region,
             :cl_lic_series, :cl_lic_number, :cl_lic_date, :cl_lic_good_date, :cl_lic_organ, :cl_lic_reg_number,
             :cl_country_kod, :cl_post_index, :cl_district_name, :cl_city_name, :cl_nas_punkt,
             :cl_street_name, :cl_house, :cl_building, :cl_appartment, :cl_is_ip;
        if (manuf_id is null or manuf_id = -1) then begin
          manuf_id = -1;
          manuf_name = '< >'; manuf_inn = ''; manuf_kpp = '';
        end else begin
          select iif(m.legal_name <> '', m.legal_name, m.name_manufacturer), m.inn, m.kpp
            from MANUFACTURER m
            where m.id_manufacturer = :manuf_id
          into manuf_name, manuf_inn, manuf_kpp;
        end
        if (group_by_articul = 1)
          then select name from CARDSCLA where articul = :articul into :goodname;
        suspend;
      end
    end
  end
end^


create or alter procedure RPT_ALKODECLROZN_OBOROT_SPEC (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    GROUP_BY_SUPERPLACE integer,
    MANUF_KIND integer,
    VIDPROD_KIND integer,
    USE_SEL_CLIENTS integer,
    SHOW_NULL_NETTO integer,
    ONLY_MOVE integer)
returns (
    DOCHEAD_ID integer,
    VIDPROD_ID integer,
    SUPERPLACE_CL_ID integer,
    MANUF_ID integer,
    ARTICUL varchar(30),
    NETTO double precision,
    OST_BEGIN double precision,
    PRIX_PROIZ double precision,
    PRIX_OPT double precision,
    PRIX_IMPORT double precision,
    PRIX_RET double precision,
    PRIX_MOVE double precision,
    PRIX_OTHER double precision,
    RASX_ROZN double precision,
    RASX_RET double precision,
    RASX_MOVE double precision,
    RASX_OTHER double precision)
AS
declare variable v_docdate date;
declare variable v_quantity double precision;
declare variable v_client_index integer;
declare variable v_client2_index integer;
declare variable v_dockind integer;
declare variable v_real_dockind integer;
declare variable v_opertype integer;
declare variable v_suptype integer;
declare variable ls_articul integer;
declare variable li_place integer;
declare variable li_client integer;
declare variable v_superplace_cl_id integer;
declare variable v_out_superplace_cl_id integer;
begin
  select handle from RPT_LIST_ARTICUL_CREATE(:report_id, :owner_id, '0;2') into :ls_articul;
  select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
  if (use_sel_clients = 1)
    then select handle from RPT_LIST_CLIENT2_CREATE(:report_id, :owner_id) into :li_client;

  v_superplace_cl_id = from_name_id;

  for select dh.id_dochead, dh.doc_date, dh.client_index, dh.client2_index, dh.dockind, op.opertype
    from DOCHEAD dh
    left join OPERATIONS op on dh.operation = op.id_operation
    where dh.accept = 'T' and dh.doc_date <= :date_last and (:only_move = 0 or dh.doc_date >= :date_first) and
          (dh.dockind in (0,1,2) and listint_exists(:li_place, dh.client2_index) = 1 or
           dh.dockind = 2 and listint_exists(:li_place, dh.client_index) = 1) and
          (:use_sel_clients = 0 or dh.dockind <> 0 or op.opertype = 1 or
           listint_exists(:li_client, dh.client_index) = 1) --      
    into :dochead_id, :v_docdate, :v_client_index, :v_client2_index, :v_dockind, :v_opertype
  do begin
    v_real_dockind = v_dockind;
    --      
    select coalesce(alko_sup_type, 0) from CLIENTS
      where id_clients = :v_client_index
    into v_suptype;
    --  
    if (group_by_superplace = 1) then begin
      v_superplace_cl_id = null;
      select sph.client_index
        from SUPERPLACE sp
        left join SUPERPLACE_HEAD sph on sph.id = sp.id
        where sp.spkind = 12 and sp.placeindex = :v_client2_index
      into v_superplace_cl_id;
      if (v_dockind = 2) then begin
        if (listint_exists(:li_place, v_client2_index) <> 1)
          then v_superplace_cl_id = null;
        v_out_superplace_cl_id = null;
        if (listint_exists(:li_place, v_client_index) = 1)
          then select sph.client_index
                 from SUPERPLACE sp
                 left join SUPERPLACE_HEAD sph on sph.id = sp.id
                 where sp.spkind = 12 and sp.placeindex = :v_client_index
               into v_out_superplace_cl_id;
        if (v_superplace_cl_id is null) then begin
          --  "" -   
          v_opertype = 2; -- ""
          v_dockind = 1;
          v_superplace_cl_id = v_out_superplace_cl_id; --   ,   = client_index
        end else
        if (v_out_superplace_cl_id is null) then begin
          --  "" -   
          v_opertype = 2; -- ""
          v_dockind = 0;
        end else
        if (v_out_superplace_cl_id = v_superplace_cl_id) then begin
          --    -   
          v_dockind = -1;
        end
        --        (-)
        --       -     
      end
    end else begin
      if (v_dockind = 2) then begin
        v_opertype = 2; -- ""
        if (listint_exists(:li_place, v_client_index)=1 and
            listint_exists(:li_place, v_client2_index)<>1)
          then v_dockind = 1; --   
          else if (listint_exists(:li_place, v_client_index)<>1 and
                   listint_exists(:li_place, v_client2_index)=1)
                 then v_dockind = 0; --   
                 else v_dockind = -1; --  
      end
    end

    if (v_superplace_cl_id is not null and v_dockind <> -1) then begin

      for select iif(:vidprod_kind = 0, cp.paramvalue, dsp.vidprod),
                 coalesce(iif(:manuf_kind = 0, cs.manufacturer, ds.manufacturer),-1),
                 ds.quantity, cs.netto, ds.articul
        from DOCSPEC ds
        left join CARDPARAMS cp on :vidprod_kind = 0 and ds.articul = cp.articul and cp.paramtype = 7
        left join DOCSPEC_PARAMS dsp on (:vidprod_kind = 1 or :vidprod_kind = 2 and :v_real_dockind = 0 and :v_opertype <> 1) and
                                        dsp.dochead = :dochead_id and dsp.articul = ds.articul
        left join CARDSCLA cs on ds.articul = cs.articul
        where ds.id_dochead = :dochead_id and liststr_exists(:ls_articul, ds.articul) = 1
        into :vidprod_id, :manuf_id, :v_quantity, :netto, :articul
      do begin

        for select iif(:vidprod_kind = 2, dsp.vidprod, :vidprod_id),
                   coalesce(iif(:manuf_kind = 2, ds.manufacturer, :manuf_id),-1),
                   rs.quantity
              from RDB$DATABASE
              left join RETSPEC rs on rs.dochead = :dochead_id and rs.articul = :articul and (:use_sel_clients = 0 or listint_exists(:li_client, rs.inclient_index) = 1)
              left join DOCSPEC ds on :manuf_kind = 2 and ds.id_dochead = rs.indochead and ds.articul = :articul
              left join DOCSPEC_PARAMS dsp on :vidprod_kind = 2 and dsp.dochead = rs.indochead and dsp.articul = :articul
              where :v_real_dockind = 0 and :v_opertype = 1 and (:vidprod_kind = 2 or :manuf_kind = 2 or :use_sel_clients = 1)
            union all
            select iif(:vidprod_kind = 2, dsp.vidprod, :vidprod_id),
                   coalesce(iif(:manuf_kind = 2, ds.manufacturer, :manuf_id),-1),
                   ps.quantity
              from RDB$DATABASE
              left join PARTSPEC ps on ps.dochead = :dochead_id and ps.articul = :articul and (:use_sel_clients = 0 or listint_exists(:li_client, ps.inclient_index) = 1)
              left join DOCSPEC ds on :manuf_kind = 2 and ds.id_dochead = ps.indochead and ds.articul = :articul
              left join DOCSPEC_PARAMS dsp on :vidprod_kind = 2 and dsp.dochead = ps.indochead and dsp.articul = :articul
              where :v_real_dockind in (1,2) and (:vidprod_kind = 2 or :manuf_kind = 2 or :use_sel_clients = 1)
            union all
            select :vidprod_id, :manuf_id, :v_quantity
              from RDB$DATABASE
              where :v_real_dockind = 0 and :v_opertype <> 1 or
                    :vidprod_kind <> 2 and :manuf_kind <> 2 and :use_sel_clients = 0
          into :vidprod_id, :manuf_id, :v_quantity
        do begin
          if (not show_null_netto = 1 or netto > 0) then v_quantity = v_quantity * netto;
          if (vidprod_id is not null) then begin
            superplace_cl_id = v_superplace_cl_id;
            ost_begin = 0;
            prix_proiz = 0; prix_opt = 0; prix_import = 0; prix_ret = 0; prix_move = 0; prix_other = 0;
            rasx_rozn = 0; rasx_ret = 0; rasx_move = 0; rasx_other = 0;

            --   
            if (v_docdate < date_first) then begin
              if (v_dockind = 0)
               then ost_begin = v_quantity;
               else if (v_dockind = 1)
                      then ost_begin = -v_quantity;
                      else if (v_dockind = 2) then begin
                             ost_begin = v_quantity;
                             suspend;
                             ost_begin = 0;
                             superplace_cl_id = v_out_superplace_cl_id;
                             ost_begin = -v_quantity;
                           end
            end
            --    
            else begin
              -- 
              if (v_dockind = 0) then begin
                if (v_opertype = 1)
                  then prix_ret = v_quantity;
                  else if (v_opertype = 2 or v_opertype = 3)
                         then prix_other = v_quantity;
                         else if (v_suptype = 0)
                                then prix_proiz = v_quantity;
                                else if (v_suptype = 1)
                                       then prix_opt = v_quantity;
                                       else if (v_suptype = 2)
                                              then prix_import = v_quantity;
              end
              -- 
              if (v_dockind = 1) then begin
               if (v_opertype = 1)
                  then rasx_ret = v_quantity;
                  else if (v_opertype = 2 or v_opertype = 3)
                         then rasx_other = v_quantity;
                         else rasx_rozn = v_quantity;

              end
              -- 
              if (v_dockind = 2) then begin
                prix_move = v_quantity;
                suspend;
                prix_move = 0;
                superplace_cl_id = v_out_superplace_cl_id;
                rasx_move = v_quantity;
              end
            end
            suspend;
          end
        end
      end
    end
  end
  execute procedure RPT_LISTS_FREE;
end^

create or alter procedure RPT_ALKODECLROZN_OBOROT (
    REPORT_ID integer,
    OWNER_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    CALC_PRECISION integer,
    GROUP_BY_SUPERPLACE integer,
    FROM_NAME_ID integer,
    MANUF_KIND integer,
    VIDPROD_KIND integer,
    USE_SEL_CLIENTS integer,
    GROUP_BY_ARTICUL integer,
    SHOW_NULL_NETTO integer,
    ONLY_MOVE integer)
returns (
    SUPERPLACE_CL_ID integer,
    VIDPROD_NAME varchar(80),
    VIDPROD_KOD varchar(40),
    MANUF_ID integer,
    MANUF_NAME varchar(255),
    MANUF_INN varchar(20),
    MANUF_KPP varchar(20),
    ARTICUL varchar(30),
    GOODNAME varchar(80),
    NETTO double precision,
    OST_BEGIN double precision,
    PRIX_PROIZ double precision,
    PRIX_OPT double precision,
    PRIX_IMPORT double precision,
    PRIX_RET double precision,
    PRIX_MOVE double precision,
    PRIX_OTHER double precision,
    RASX_ROZN double precision,
    RASX_RET double precision,
    RASX_MOVE double precision,
    RASX_OTHER double precision)
AS
declare variable v_vidprod_id integer;
begin
  setpriority(-15);

  for select superplace_cl_id, vidprod_id, manuf_id,
             iif(:group_by_articul = 1, articul, null), iif(:group_by_articul = 1, netto, null),
             sum(ost_begin),
             sum(prix_proiz), sum(prix_opt),
             sum(prix_import), sum(prix_ret),
             sum(prix_move), sum(prix_other),
             sum(rasx_rozn), sum(rasx_ret),
             sum(rasx_move), sum(rasx_other)
    from (select superplace_cl_id, vidprod_id, manuf_id,
                 iif(:group_by_articul = 1, articul, null) articul,
                 iif(:group_by_articul = 1, netto, null) netto,
                 round(sum(ost_begin)/10, :calc_precision) ost_begin,
                 round(sum(prix_proiz)/10, :calc_precision) prix_proiz, round(sum(prix_opt)/10, :calc_precision) prix_opt,
                 round(sum(prix_import)/10, :calc_precision) prix_import, round(sum(prix_ret)/10, :calc_precision) prix_ret,
                 round(sum(prix_move)/10, :calc_precision) prix_move, round(sum(prix_other)/10, :calc_precision) prix_other,
                 round(sum(rasx_rozn)/10, :calc_precision) rasx_rozn, round(sum(rasx_ret)/10, :calc_precision) rasx_ret,
                 round(sum(rasx_move)/10, :calc_precision) rasx_move, round(sum(rasx_other)/10, :calc_precision) rasx_other
            from RPT_ALKODECLROZN_OBOROT_SPEC (:report_id, :owner_id, :from_name_id, :date_first, :date_last,
                                               :group_by_superplace, :manuf_kind, :vidprod_kind, :use_sel_clients,
                                               :show_null_netto, :only_move)
            group by superplace_cl_id, vidprod_id, manuf_id, dochead_id,
                  iif(:group_by_articul = 1, articul, null), iif(:group_by_articul = 1, netto, null))
    group by superplace_cl_id, vidprod_id, manuf_id,
             iif(:group_by_articul = 1, articul, null), iif(:group_by_articul = 1, netto, null)
    into :superplace_cl_id, :v_vidprod_id, :manuf_id,
         :articul, :netto, 
         :ost_begin,
         :prix_proiz, :prix_opt,
         :prix_import, :prix_ret,
         :prix_move, :prix_other,
         :rasx_rozn, :rasx_ret,
         :rasx_move, :rasx_other
  do begin
    if (cmp_dbl_e(ost_begin, 0) <> 0 or
        cmp_dbl_e(prix_proiz, 0) <> 0 or cmp_dbl_e(prix_opt, 0) <> 0 or
        cmp_dbl_e(prix_import, 0) <> 0 or cmp_dbl_e(prix_ret, 0) <> 0 or
        cmp_dbl_e(prix_move, 0) <> 0 or cmp_dbl_e(prix_other, 0) <> 0 or
        cmp_dbl_e(rasx_rozn, 0) <> 0 or cmp_dbl_e(rasx_ret, 0) <> 0 or
        cmp_dbl_e(rasx_move, 0) <> 0 or cmp_dbl_e(rasx_other, 0) <> 0) then begin

      select name, kod
        from VID_PROD
        where id = :v_vidprod_id
      into vidprod_name,  vidprod_kod;

      if (vidprod_kod not in ('500','510','520')) then begin

        if (manuf_id is null or manuf_id = -1) then begin
          manuf_id = -1;
          manuf_name = '< >'; manuf_inn = ''; manuf_kpp = '';
        end else begin
          select iif(m.legal_name <> '', m.legal_name, m.name_manufacturer), m.inn, m.kpp
            from MANUFACTURER m
            where m.id_manufacturer = :manuf_id
          into manuf_name, manuf_inn, manuf_kpp;
        end
        if (group_by_articul = 1)
          then select name from CARDSCLA where articul = :articul into :goodname;
        suspend;
      end
    end
  end
end^


GRANT EXECUTE ON PROCEDURE RPT_ALKODECLROZN_OBOSOB TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLROZN_BUY_SPEC TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLROZN_BUY TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLROZN_OBOROT_SPEC TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLROZN_OBOROT TO PUBLIC^

SET TERM ; ^

COMMIT;
