/* 
 * S-Market: "    " 
 *    "-", 2013  
 */ 

SET TERM ^ ;

create or alter procedure RPT_ALKODECLTRANSPORT_OBOSOB (
    REPORT_ID integer,
    OWNER_ID integer,
    FROM_NAME_ID integer,
    GROUP_BY_SUPERPLACE integer)
returns (
    CL_ID integer,
    CL_NAME varchar(255),
    CL_INN varchar(20),
    CL_KPP varchar(20),
    CL_ADDRESS varchar(255),
    CL_COUNTRY_KOD varchar(3),
    CL_POST_INDEX varchar(6),
    CL_REGION varchar(2),
    CL_DISTRICT varchar(40),
    CL_CITY varchar(100),
    CL_CITY_CLEAR varchar(40),
    CL_NAS_PUNKT varchar(40),
    CL_STREET varchar(40),
    CL_HOUSE varchar(20),
    CL_HOUSE_CLEAR varchar(7),
    CL_BUILDING varchar(7),
    CL_APPARTMENT varchar(7))
AS
declare variable li_place integer;
begin

  cl_id = -1; cl_name = '-'; cl_inn = '-'; cl_kpp = '-';
  cl_address = ''; cl_post_index = ''; cl_region = ''; cl_district = '';
  cl_city = ''; cl_street = ''; cl_house = '';

  if (group_by_superplace = 1) then begin
    select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
    for select distinct cl.id_clients, iif(cl.legal_name <> '', cl.legal_name, cl.name_clients),  iif(cl.inn_clients <> '', cl.inn_clients, '-'), iif(cl.kpp <> '', cl.kpp, '-'),
               ad.address, ad.country_kod, ad.post_index, ad.region_kod, ad.district_name,
               iif(ad.nas_punkt = '', ad.city_name, ad.city_name ||' \ ')||ad.nas_punkt,
               ad.city_name, ad.nas_punkt,
               ad.street_name, ad.house || iif (ad.building <> '', ' \ ' || ad.building, ''),
               ad.house, ad.building, ad.appartment
      from SUPERPLACE sp
      left join SUPERPLACE_HEAD sph on sph.id = sp.id
      inner join CLIENTS cl on cl.id_clients = sph.client_index
      left join GET_ADDRESS_KLADR(0, cl.id_clients) ad on 1=1
      where sp.spkind = 12 and listint_exists(:li_place, sp.placeindex) = 1
      into :cl_id, :cl_name, :cl_inn, :cl_kpp,
           :cl_address, :cl_country_kod, :cl_post_index, :cl_region, :cl_district,
           :cl_city,
           :cl_city_clear, :cl_nas_punkt,
           :cl_street, :cl_house,
           :cl_house_clear, :cl_building, :cl_appartment
    do suspend;
    execute procedure RPT_LISTS_FREE;
  end else begin
    select cl.id_clients, iif(cl.legal_name <> '', cl.legal_name, cl.name_clients),  iif(cl.inn_clients <> '', cl.inn_clients, '-'), iif(cl.kpp <> '', cl.kpp, '-'),
           ad.address, ad.country_kod, ad.post_index, ad.region_kod, ad.district_name,
           iif(ad.nas_punkt = '', ad.city_name, ad.city_name ||' \ ')||ad.nas_punkt,
           ad.city_name, ad.nas_punkt,
           ad.street_name, ad.house || iif (ad.building <> '', ' \ ' || ad.building, ''),
           ad.house, ad.building, ad.appartment
      from CLIENTS cl
      left join GET_ADDRESS_KLADR(0, :from_name_id) ad on 1=1
      where cl.id_clients = :from_name_id
    into :cl_id, :cl_name, :cl_inn, :cl_kpp,
         :cl_address, :cl_country_kod, :cl_post_index, :cl_region, :cl_district,
         :cl_city,
         :cl_city_clear, :cl_nas_punkt,
         :cl_street, :cl_house,
         :cl_house_clear, :cl_building, :cl_appartment;
    suspend;
  end
end^

create or alter procedure RPT_ALKODECLTRANSPORT_SPEC (
    REPORT_ID integer,
    OWNER_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    GROUP_BY_SUPERPLACE integer,
    FROM_NAME_ID integer)
returns (
    SUPERPLACE_CL_ID integer,
    VIDTRANS_KOD varchar(40),
    VIDPROD_KOD varchar(40),
    CLIENT_ID integer,
    BUYER_ID integer,
    TRANS_TYPE varchar(255),
    TRANS_VOLUME double precision,
    TRANS_NUMBER varchar(100),
    TN_DATE date,
    TN_INDEX varchar(100),
    EXT_DOC_DATE date,
    EXT_DOCINDEX T_EXT_DOC_INDEX,
    QUANTITY double precision)
AS
declare variable v_dochead integer;
declare variable v_dockind integer;
declare variable v_place integer;
declare variable ls_articul integer;
declare variable li_place integer;
declare variable li_client integer;
begin
  vidtrans_kod = '';  --  !!! ,     -  
  vidprod_kod = '';  --  !!! ,     -  

  select handle from RPT_LIST_ARTICUL_CREATE(:report_id, :owner_id, '0;2') into :ls_articul;
  select handle from RPT_LIST_PLACE_CREATE(:report_id, :owner_id) into :li_place;
  select handle from RPT_LIST_CLIENT_CREATE(:report_id, :owner_id) into :li_client;

  superplace_cl_id = from_name_id;

  for select dh.dockind, dh.id_dochead, dh.client_index, dh.client2_index,
             dh.ext_doc_date, dh.ext_docindex, --    
             strtodatefmt('dd.mm.yyyy', dh.add_param6),  dh.add_param5, --  !   (   )
             '', strtoint(dh.add_param7), dh.add_param4 --  !        . 
    from DOCHEAD dh
    left join OPERATIONS op on dh.operation = op.id_operation
    where dh.accept = 'T' and
          dh.doc_date between :date_first and :date_last and
          dh.dockind in (0, 1) and op.opertype = 0 and dh.doctype <> 1001 and
          listint_exists(:li_place, dh.client2_index) = 1 and
          listint_exists(:li_client, dh.client_index) = 1
    into :v_dockind, :v_dochead, :client_id, :v_place,
         :ext_doc_date, :ext_docindex,
         :tn_date, :tn_index,
         :trans_type, :trans_volume, :trans_number
  do begin
    if (group_by_superplace = 1) then begin
      superplace_cl_id = null;
      select sph.client_index
        from SUPERPLACE sp
        left join SUPERPLACE_HEAD sph on sph.id = sp.id
        where sp.spkind = 12 and sp.placeindex = :v_place
      into superplace_cl_id;
    end
    if (superplace_cl_id is not null) then begin
      --  !
      --      
      if (v_dockind = 0) then begin
        --   -  -  (),   
        buyer_id = superplace_cl_id;
      end else begin
        --   -  - ,    ()
        buyer_id = client_id; client_id = superplace_cl_id;
      end

      select coalesce(sum(ds.quantity * cs.netto),0)
        from DOCSPEC ds
        inner join CARDPARAMS cp on ds.articul = cp.articul and cp.paramtype = 7 --   ,   
        left join CARDSCLA cs on ds.articul = cs.articul
        where ds.id_dochead = :v_dochead and
              liststr_exists(:ls_articul, ds.articul) = 1 and
              cp.paramvalue is not null --   ,   
      into :quantity;
      if (quantity > 0) then suspend;

    end
  end
  execute procedure RPT_LISTS_FREE;
end^

create or alter procedure RPT_ALKODECLTRANSPORT (
    REPORT_ID integer,
    OWNER_ID integer,
    DATE_FIRST date,
    DATE_LAST date,
    CALC_PRECISION integer,
    GROUP_BY_SUPERPLACE integer,
    FROM_NAME_ID integer)
returns (
    SUPERPLACE_CL_ID integer, --    ()
    VIDTRANS_KOD varchar(40), --   ( - ,  - ,  - ,  - ,  - )
    VIDPROD_KOD varchar(40),  --   ( -  ,  -  ,  -   , -   )
    --   :
    CL_ID integer,            -- 
    CL_IS_IP integer,         -- 1 -  , 0 -  
    CL_NAME varchar(255),      --    ,     (,  )
        --    
    CL_INN varchar(20),       -- 
    CL_KPP varchar(20),       -- 
        --    
    CL_COUNTRY_KOD varchar(3),
    CL_POST_INDEX varchar(6),
    CL_REGION varchar(2),
    CL_DISTRICT_NAME varchar(40),
    CL_CITY_NAME varchar(40),
    CL_NAS_PUNKT varchar(40),
    CL_STREET_NAME varchar(40),
    CL_HOUSE varchar(7),
    CL_BUILDING varchar(7),
    CL_APPARTMENT varchar(7),
        -- 
    CL_LIC_SERIES varchar(20),-- 
    CL_LIC_NUMBER varchar(20),-- 
    CL_LIC_DATE date,         --  
    CL_LIC_GOOD_DATE date,    --   
    CL_LIC_ORGAN varchar(255),-- ,  
    CL_LIC_REG_NUMBER varchar(255),--   
    --    
    TRANS_TYPE varchar(255),  -- 
    TRANS_VOLUME double precision,--  ( )
    TRANS_NUMBER varchar(100),--  
    --   
    BUYER_ID integer,         -- 
    BUYER_NAME varchar(255),   -- 
    BUYER_INN varchar(20),    -- 
    BUYER_KPP varchar(20),    -- 
    --   
    TN_DATE date,              --   
    TN_INDEX varchar(100),     --   
    TN_QUANTITY double precision, --  ()   .  
    --   
    EXT_DOC_DATE date,        --  
    EXT_DOCINDEX T_EXT_DOC_INDEX, --  
    QUANTITY double precision)--  , 
AS
begin
  setpriority(-15);

  for select superplace_cl_id, vidtrans_kod, vidprod_kod, client_id, buyer_id,
             trans_type, trans_volume, trans_number,
             tn_date, tn_index, ext_doc_date, ext_docindex,
             round(sum(quantity) / 10, :calc_precision)
    from RPT_ALKODECLTRANSPORT_SPEC (:report_id, :owner_id, :date_first, :date_last, :group_by_superplace, :from_name_id)
    group by superplace_cl_id, vidtrans_kod, vidprod_kod, client_id, buyer_id,
             trans_type, trans_volume, trans_number,
             tn_date, tn_index, ext_doc_date, ext_docindex
    into :superplace_cl_id, :vidtrans_kod, :vidprod_kod, :cl_id, :buyer_id,
         :trans_type, :trans_volume, :trans_number,
         :tn_date, :tn_index, :ext_doc_date, :ext_docindex,
         :quantity
  do begin
    if (cmp_dbl_e(quantity, 0) <> 0) then begin
      tn_quantity = quantity; --  -   =  

      select iif(cl.legal_name <> '', cl.legal_name, cl.name_clients), cl.inn_clients, cl.kpp, ad.region_kod,
             clic.lic_series, clic.lic_number, clic.lic_date, clic.lic_gooddate, clic.lic_organ, clic.lic_reg_number,
             ad.country_kod, ad.post_index, ad.district_name, ad.city_name, ad.nas_punkt,
             ad.street_name, ad.house, ad.building, ad.appartment, coalesce(ok.is_ip, 0)
        from CLIENTS cl
        left join OWNKIND ok on ok.id = cl.ownkind
        left join CLIENT_LIC_VIEW(cl.id_clients, :ext_doc_date) clic on 1=1
        left join GET_ADDRESS_KLADR(0, :cl_id) ad on 1=1
        where cl.id_clients = :cl_id
      into :cl_name, :cl_inn, :cl_kpp, cl_region,
           :cl_lic_series, :cl_lic_number, :cl_lic_date, :cl_lic_good_date, :cl_lic_organ, :cl_lic_reg_number,
           :cl_country_kod, :cl_post_index, :cl_district_name, :cl_city_name, :cl_nas_punkt,
           :cl_street_name, :cl_house, :cl_building, :cl_appartment, :cl_is_ip;

      select iif(cl.legal_name <> '', cl.legal_name, cl.name_clients), cl.inn_clients, cl.kpp
        from CLIENTS cl
        left join OWNKIND ok on ok.id = cl.ownkind
        where cl.id_clients = :buyer_id
      into :buyer_name, :buyer_inn, :buyer_kpp;

      suspend;
    end
  end
end^

GRANT EXECUTE ON PROCEDURE RPT_ALKODECLTRANSPORT_OBOSOB TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLTRANSPORT_SPEC TO PUBLIC^
GRANT EXECUTE ON PROCEDURE RPT_ALKODECLTRANSPORT TO PUBLIC^

SET TERM ; ^

COMMIT;
